#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <karma.h>
#include <karma_ch.h>

int main (int argc, char *argv[])
{
    flag quoted;
    flag another;
    Channel infile;
    FILE *outfile;
    char *ptr;
    char *end;
    char buffer[STRING_LENGTH];
    static char usage_string[] = "Usage:\tdos_headers [infile] [outfile]";

    if (argc > 3)
    {
	(void) fputs (usage_string, stderr);
	exit (RV_TOO_MANY_PARAM);
    }
    ch_open_stdin ();
    if (argc > 1)
    {
	if ( ( infile = ch_open_file (argv[1], "r") ) == NULL )
	{
	    (void) fprintf (stderr,
			    "Error opening file: \"%s\" for input\t%s\n",
			    argv[1], ERRSTRING);
	    exit (RV_CANNOT_OPEN);
	}
    }
    else
    {
	infile = ch_stdin;
    }
    
    if (argc > 2)
    {
	if ( ( outfile = fopen (argv[2], "w") ) == NULL )
	{
	    (void) fprintf (stderr,
			    "Error opening file: \"%s\" for output\t%s\n",
			    argv[2], ERRSTRING);
	    exit (RV_CANNOT_OPEN);
	}
    }
    else
    {
	outfile = stdout;
    }
    /*  Read one line at a time  */
    while ( ch_gets (infile, buffer, STRING_LENGTH) )
    {
	another = TRUE;
	/*  Search for comment  */
	end = buffer + strlen (buffer);
	quoted = (buffer[0] == '"') ? TRUE : FALSE;
	for (ptr = buffer + 1; (ptr < end) && another; ++ptr)
	{
	    switch (*ptr)
	    {
	      case '"':
		/*  Quote  */
		if (*(ptr - 1) != '\\')
		{
		    /*  Syntactic quote  */
		    quoted = quoted ? FALSE : TRUE;
		}
		break;
	      case '/':
		/*  First comment character  */
		if ( !quoted && (*(ptr - 1) == '/') )
		{
		    /*  Real comment  */
		    *ptr = '*';
		    (void) strcat (buffer, "  */");
		    another = FALSE;
		}
		break;
	    }
	}
	if (buffer[0] != '#')
	{
	    (void) fprintf (outfile, "%s\n", buffer);
	    continue;
	}
	/*  Search for first non-whitespace  */
	for (ptr = buffer + 1; isspace (*ptr); ++ptr);
	if (*ptr == '\0')
	{
	    (void) fprintf (stderr, "Bad line: \"%s\"\n", buffer);
	    exit (RV_BAD_DATA);
	}
	if (strncmp (ptr, "include", 7) != 0)
	{
	    (void) fprintf (outfile, "%s\n", buffer);
	    continue;
	}
	/*  Is  #include  */
	/*  Search for first non-whitespace  */
	for (ptr += 7; isspace (*ptr); ++ptr);
	if (*ptr == '"')
	{
	    (void) fprintf (outfile, "%s\n", buffer);
	    continue;
	}
	if (*ptr != '<')
	{
	    (void) fprintf (stderr, "Bad line: \"%s\"\n", buffer);
	    exit (RV_BAD_DATA);
	}
	++ptr;
	if (strncmp (ptr, "karma_", 6) != 0)
	{
	    (void) fprintf (outfile, "%s\n", buffer);
	    continue;
	}
	/*  Modify  */
	(void) fprintf (outfile, "#include <k_%s\n", ptr + 6);
    }
    (void) fclose (outfile);
    (void) ch_close (infile);
    exit (RV_OK);
}   /*  End Function main  */
