/*  MultibeamView.h

    Include file for  MultibeamView  (X11 image/movie display tool for Karma).

    Copyright (C) 1997-2004  Richard Gooch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*
    This Karma module will enable on-screen imaging.
    This module runs on an X11 server.


    Written by      Richard Gooch   9-JAN-1997

    Last updated by Richard Gooch   14-APR-2004


*/
#include <karma.h>


/*  File: main_xt.c  */
EXTERN_FUNCTION (void new_scroll_array, () );
EXTERN_FUNCTION (void updated_scroll_array, (long plane_index) );

/*  File: scroll.c  */
EXTERN_FUNCTION (void copy_plane, (iarray array, unsigned long plane_index,
				   CONST void *in, double blank) );
EXTERN_FUNCTION (void copy_line_of_doubles,
		 (iarray array, CONST double *data, uaddr ypos,double scale) );

/*  File glish.cc  */
EXTERN_FUNCTION (flag scroll_init_cbk,
		 (CONST void *client_ptr, void *object, CONST char *name,
		  CONST void *value_ptr) );
EXTERN_FUNCTION (flag scroll_add_cbk,
		 (CONST void *client_ptr, void *object, CONST char *name,
		  CONST void *value_ptr) );
