/*  kview.h

    Include file for  kview  (X11 image+contour display tool for Karma).

    Copyright (C) 1997-2000  Richard Gooch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*
    This Karma module will enable on-screen display of an image overlayed with
    contours from another image/cube.
    This module runs on an X11 server.


    Written by      Richard Gooch   24-JAN-1997

    Last updated by Richard Gooch   12-JUL-2000


*/
#include <karma.h>
#include <karma_iarray_def.h>

typedef struct
{
    iarray array_pseudo;
    iarray array_red;
    iarray array_green;
    iarray array_blue;
    double min;
    double max;
} Dataset;


/*  File: main_xt.c  */

/*  File: generic.c  */
EXTERN_FUNCTION (flag process_set, (multi_array *multi_desc, Dataset *set) );
