/*  kpolar.h

    Include file for  kpolar  (X11 cartesian->polar tool for Karma).

    Copyright (C) 1997-2000  Richard Gooch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*
    This Karma module will enable interactive conversion of a cartesian image
    to a polar image.
    This module runs on an X11 server.


    Written by      Richard Gooch   5-AUG-1997

    Last updated by Richard Gooch   12-JUL-2000


*/
#include <karma.h>
#include <karma_viewimg_def.h>
#include <karma_canvas_def.h>
#include <karma_iarray_def.h>
#include <karma_kcmap_def.h>
#include <karma_kwin_def.h>
#include <karma_psw_def.h>
#include <karma_wcs_def.h>
#include <k_win_scale.h>


/*  File: main_xt.c  */
EXTERN_FUNCTION (void update_polar_dataclip,
		 (iarray array, double min, double max) );

/*  File: generic.c  */
EXTERN_FUNCTION (flag process_image,
		 (multi_array *multi_desc, iarray *array, KwcsAstro *ap,
		  KWorldCanvas pseudo_canvas, KWorldCanvas mag_pseudo_canvas,
		  ViewableImage *image, ViewableImage *magnified_image,
		  double *min, double *max) );

/*  File: event.c  */
EXTERN_FUNCTION (flag geom_func,
		 (KPixCanvasEditorContext context,KPixCanvas canvas,
		  unsigned int object_type, unsigned int num_coords,
		  CONST int *x, CONST int *y,
		  unsigned int raw_event_code, void *raw_e_info,
		  void **f_info) );
EXTERN_FUNCTION (void car_refresh_func,
		 (KWorldCanvas canvas, int width, int height,
		  struct win_scale_type *win_scale,
		  Kcolourmap cmap, flag cmap_resize, void **info,
		  PostScriptPage pspage,
		  unsigned int num_areas, KPixCanvasRefreshArea *areas,
		  flag *honoured_areas) );
