/*  Main program (skeletal version) to drive various components of Karma.


    Written by      Richard Gooch   16-OCT-1992

    Updated by      Richard Gooch   16-OCT-1992

    Updated by      Richard Gooch   23-DEC-1992: Allow one incoming multi_array
  connection.

    Updated by      Richard Gooch   25-DEC-1992: Added summation/ accumulation
  of images.

    Updated by      Richard Gooch   4-JAN-1993: Set default memory mapping
  option to  K_CH_MAP_ALWAYS  .

    Updated by      Richard Gooch   28-MAR-1993: Removed previous change.

    Updated by      Richard Gooch   4-APR-1993: Took account of change to
  conn_register_server_protocol  and  conn_register_client_protocol  .

    Updated by      Richard Gooch   14-SEP-1993: Took account of change to
  module_run  .

    Updated by      Richard Gooch   29-SEP-1993: Removed  #include "date.h"

    Updated by      Richard Gooch   29-NOV-1993: Removed
  #include <c_varieties.h>

    Last updated by Richard Gooch   27-JUN-1999: Added call to <init_panel>.


*/
#include <stdio.h>
#include <karma.h>
#include <karma_module.h>
#include <karma_conn.h>
#include "persp_3d.h"

#define VERSION "1.2"


int main (int argc, char **argv)
{
    /*  Register the "persp_3d_images" event callbacks  */
    conn_register_server_protocol ("persp_3d_images", 0, MAX_INCOMING_IMAGES,
				   image_open_func,
				   image_read_func,
				   ( void (*) () ) NULL);
    conn_register_client_protocol ("persp_3d_images", 0, 1,
				   verify_connect,
				   ( flag (*) () ) NULL,
				   ( flag (*) () ) NULL,
				   ( void (*) () ) NULL);
    /*  Register the "processing_finished" server protocol  */
    conn_register_server_protocol ("processing_finished", 0, 0,
				   ( flag (*) () ) NULL,
				   ( flag (*) () ) NULL,
				   ( void (*) () ) NULL);
    init_panel ();
    module_run (argc, argv, "persp_3d", VERSION, ( flag (*) () ) render, 0, 1,
		TRUE);
    return (RV_OK);
}   /*  End Function main   */
