/*  RenderDisplayPopupP.h

    Private header for  RenderDisplayPopup  widget class.

    Copyright (C) 1997-1998  Richard Gooch

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*

    This include file contains the private class declarations for the
  RenderDisplayPopup widget, a simple RenderDisplay display widget for
  Xt.


    Written by      Richard Gooch   9-DEC-1997

    Last updated by Richard Gooch   17-JUN-1998

*/
#ifndef RenderDisplayPopupP__H
#define RenderDisplayPopupP__H

#include <X11/IntrinsicP.h>
#include <X11/ShellP.h>
#include <X11/StringDefs.h>

#include <Xkw/SlaveImageDisplayPopupP.h>
/*#include <Xkw/RenderDisplayPopup.h>*/
#include "RenderDisplayPopup.h"

typedef struct _RenderDisplayPopupPart
{
    /*  Public resources  */
    KVolumeRenderContext vrend_ctx;
    XtPointer preRenderFunction;
    /*  Private resources  */
    char *left_buffer;
    char *right_buffer;
    uaddr buffer_bytes;
    ViewableImage left_vimage;
    ViewableImage right_vimage;
    flag last_was_stereo;
} RenderDisplayPopupPart, *RenderDisplayPopupPartPtr;

typedef struct _RenderDisplayPopupRec
{
    CorePart core;
    CompositePart composite;
    ShellPart shell;
    WMShellPart wm;
    VendorShellPart vendor;
    TopLevelShellPart topLevel;
    SlaveImageDisplayPopupPart slaveImageDisplayPopup;
    RenderDisplayPopupPart renderDisplayPopup;
} RenderDisplayPopupRec, *RenderDisplayPopupPtr;

typedef struct _RenderDisplayPopupClassPart
{
    int empty;
} RenderDisplayPopupClassPart;

typedef struct _RenderDisplayPopupClassRec
{
    CoreClassPart core_class;	
    CompositeClassPart composite_class;
    ShellClassPart shell_class;
    WMShellClassPart wm_shell_class;
    VendorShellClassPart vendor_shell_class;
    TopLevelShellClassPart top_level_shell_class;
    SlaveImageDisplayPopupClassPart slaveImageDisplayPopup_class;
    RenderDisplayPopupClassPart renderDisplayPopup_class;
} RenderDisplayPopupClassRec, *RenderDisplayPopupClassPtr;

extern RenderDisplayPopupClassRec renderDisplayPopupClassRec;

#endif
