/*  c2olddoc.c

    Source file for  c2olddoc  (extract documentation from C code).

    Copyright (C) 1993-1999  Richard Gooch

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*  This Karma utility programme will read a C source file and extract
  documentation. This programme expects documentation in the old style.


    Written by      Richard Gooch   1993

    Last updated by Richard Gooch   30-MAR-1996: Renamed this from "c2doc" to
  "c2olddoc".

    Last updated by Richard Gooch   15-AUG-1999: Made egcs happy.


*/
#include <stdio.h>
#include <string.h>
#include <karma.h>


void skip_until ();

int main (int argc, char *argv[])
{
    FILE *fp_in;
    FILE *fp_out;
    char txt[STRING_LENGTH + 1];
    extern int errno;

    if (argc == 2)
    {
	if ( ( fp_in = fopen (argv[1], "r") ) == NULL )
	{
	    (void) fprintf (stderr, "Error opening file: \"%s\"\t%s\n",
			    argv[1], ERRSTRING);
	    exit (1);
	}
    }
    else
    {
	fp_in = stdin;
    }
    fp_out = stdout;
    /*  Process lines  */
    /*  Start looking for functions  */
    while (1 == 1)
    {
	skip_until (fp_in, "/*PUBLIC_FUNCTION*/", txt, STRING_LENGTH);
	if (txt[0] == '\0')
	{
	    exit (0);
	}
	/*  Another function to process  */
	if (fgets (txt, STRING_LENGTH, fp_in) == NULL)
	{
	    exit (0);
	}
	(void) fputs ("\n", fp_out);
	while (txt[0] != '{')
	{
	    (void) fputs (txt, fp_out);
	    if (fgets (txt, STRING_LENGTH, fp_in) == NULL)
	    {
		exit (0);
	    }
	}
/*
	(void) fputs ("{}\n", fp_out);
*/
	(void) fputs ("/*---------------------------------------------------------------------------*/\n",
		      fp_out);
    }
    return (0);
}   /*  End Function main  */

void skip_until (fp, string, out_string, length)
FILE *fp;
char *string;
char *out_string;
unsigned int length;
{
    while (fgets (out_string, length, fp) != NULL)
    {
	if (strncmp ( out_string, string, strlen (string) ) == 0)
	{
	    return;
	}
    }
    out_string[0] = '\0';
}
