#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <karma.h>


void skip_until ();

int main (int argc, char *argv[])
{
    FILE *fp_in;
    FILE *fp_out;
    char *c_ptr;
    char txt[STRING_LENGTH + 1];
    extern int errno;

    if (argc == 2)
    {
	if ( ( fp_in = fopen (argv[1], "r") ) == NULL )
	{
	    (void) fprintf (stderr, "Error opening file: \"%s\"\t%s\n",
			    argv[1], ERRSTRING);
	    exit (1);
	}
    }
    else
    {
	fp_in = stdin;
    }
    fp_out = stdout;
    /*  Process lines  */
    /*  Start looking for functions  */
    while (1 == 1)
    {
	skip_until (fp_in, "/*PUBLIC_FUNCTION*/", txt, STRING_LENGTH);
	if (txt[0] == '\0')
	{
	    exit (0);
	}
	/*  Another function to process  */
	if (fgets (txt, STRING_LENGTH, fp_in) == NULL)
	{
	    exit (0);
	}
	/*  Remove after brackets  */
	if ( ( c_ptr = strchr (txt, '(') ) == NULL )
	{
	    (void) fprintf (stderr, "'(' missing from function line\n");
	    exit (1);
	}
	*c_ptr = '\0';
	/*  Remove trailing whitespace  */
	while (c_ptr > txt)
	{
	    if ( isspace (*c_ptr) )
	    {
		*c_ptr = '\0';
		c_ptr = txt;
	    }
	    else
	    {
		--c_ptr;
	    }
	}
	/*  Remove return type of function  */
	c_ptr = txt + strlen (txt) - 1;
	while ( (c_ptr >= txt) && (*c_ptr != '*') && ( ! isspace (*c_ptr) ) )
	{
	    --c_ptr;
	}
	++c_ptr;
	(void) fputs (c_ptr, fp_out);
	(void) fputs ("\n", fp_out);
	while (txt[0] != '{')
	{
	    if (fgets (txt, STRING_LENGTH, fp_in) == NULL)
	    {
		exit (0);
	    }
	}
    }
    return (0);
}   /*  End Function main  */

void skip_until (fp, string, out_string, length)
FILE *fp;
char *string;
char *out_string;
unsigned int length;
{
    while (fgets (out_string, length, fp) != NULL)
    {
	if (strncmp ( out_string, string, strlen (string) ) == 0)
	{
	    return;
	}
    }
    out_string[0] = '\0';
}
